/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include "binforge.h"
#include "server.h"
#include "server.c"

#define BFS_VERSION "0.1.0"

int init();
void destroy();

int main()
{
    if (init() == false)
		return 0;

    sck_init();

    server_start();

    sck_clear();

    destroy();
	printf("\nGood bye :)\n");
	return 0;
}

int init() {
	printf("binforge server v%s\n", BFS_VERSION);

	// Repository initialization
	printf("Repository initialization... ");
	if (pkgr_init() == false) {
		printf("failed.\nCould not initialize the repository.\n");
		return false;
	}
	else
		printf("done.\n");

	// Repository database opening
	printf("Repository database opening... ");
	if (pkgdb_open() == false) {
		printf("failed.\nCould not open the repository database.\n");
		return false;
	}
	else
		printf("done.\n");

	// Repository database opening
	printf("Winsock initialization... ");
	if (sck_init() != 0) {
		printf("failed.\nCould not initialize winsock.\n");
		return false;
	}
	else
		printf("done.\n");

	return true;
}

void destroy() {
	// Repository database closing
	printf("Repository database closing... ");
	pkgdb_close();
	printf("done.\n");

	// Winsock cleaning
	printf("Clear winsock... ");
	sck_clear();
	printf("done.\n");

}
